blob: 3600a5b50a61d8b69ce885548d5f8a931bc43436 [file] [log] [blame]
Joel Fernandes6c1ca312018-03-30 17:13:15 -07001#!/bin/bash -e
Joel Fernandesefe6c4c2018-04-01 21:24:02 -07002#
Joel Fernandes1ed30d72018-05-18 14:08:20 -07003# (c) Joel Fernandes <joel@joelfernandes.org>
Joel Fernandesefe6c4c2018-04-01 21:24:02 -07004
Erick Reyesdd195c02018-08-16 14:50:47 -07005VERSION=v0.99g
Joel Fernandesa67be0b2018-04-01 13:40:34 -07006
Joel Fernandes464193e2018-04-02 23:54:49 -07007spath="$(dirname "$(readlink -f "$0")")"
8# spath=$( cd "$(dirname "$0")" ; pwd -P )
Joel Fernandes4fb97ea2018-03-31 11:15:19 -07009curdir=$( pwd -P )
Joel Fernandes4e19ccd2018-07-08 17:23:07 -070010source $spath/utils/support
Joel Fernandesca8fb552018-04-01 13:48:16 -070011source $spath/utils/banners
Joel Fernandes83676b12018-03-30 23:33:47 -070012
Joel Fernandes6c1ca312018-03-30 17:13:15 -070013# Set default vars
Joel Fernandesf0c54092018-04-01 19:05:10 -070014DISTRO=buster; ARCH=arm64
Joel Fernandes02939a32018-04-02 22:18:10 -070015ADB="adb"
Joel Fernandes6975db22018-07-11 20:53:16 -070016FULL=0 # Default to a minimal install
17DOWNLOAD=1 # Default to downloading from web
Joel Fernandesfdc52002018-07-08 18:49:20 -070018SKIP_DEVICE=0 # Skip device preparation
Joel Fernandesffcbfe42018-07-08 19:08:02 -070019INSTALL_BCC=0 # Decide if BCC is to be installed
Joel Fernandesf0c54092018-04-01 19:05:10 -070020
21# Default packages
Joel Fernandes6975db22018-07-11 20:53:16 -070022PACKAGES=""
23DEFAULT_PACKAGES="bash ca-certificates apt net-tools iputils-ping procps vim"
Joel Fernandes (Google)4f711082018-05-29 16:23:15 -070024
Joel Fernandes (Google)4b216fd2018-05-29 12:33:27 -070025EXTRA_FILES="none"
Joel Fernandes6c1ca312018-03-30 17:13:15 -070026
Joel Fernandesab5f9282018-04-05 22:53:23 -070027config_full_build() {
Joel Fernandes (Google)d7f21f12018-05-27 20:19:51 -070028 for f in $(ls $spath/packages); do source $spath/packages/$f; done;
Joel Fernandesab5f9282018-04-05 22:53:23 -070029}
30
Joel Fernandes6c1ca312018-03-30 17:13:15 -070031# Parse command line parameters
Joel Fernandes5b4be9c2018-03-30 23:58:27 -070032if [ $# -lt 1 ]; then usage; fi; POSITIONAL=()
Joel Fernandes4fb97ea2018-03-31 11:15:19 -070033while [[ $# -gt 0 ]]; do key="$1";
Joel Fernandesccb993f2018-07-02 19:59:04 -070034
35# If its shell mode, any future args become shell's args
36if [ "x$ASHELL" == "x1" ]; then
37 if [ -z "$SHELL_ARGS" ]; then
38 SHELL_ARGS=$key
39 else
40 SHELL_ARGS="$SHELL_ARGS $key"
41 fi
42 shift || true; continue
43fi
44
Joel Fernandes6c1ca312018-03-30 17:13:15 -070045case $key in
Joel Fernandese2a04662018-03-31 19:33:23 -070046 shell) ASHELL=1; shift || true; ;;
Joel Fernandesb4c80a62018-04-02 22:37:22 -070047 remove) REMOVE=1; shift || true; ;;
Erick Reyese25caea2018-06-19 15:42:59 -070048 git-pull) GIT_PULL=1; shift || true; ;;
49 pull) PULL=1; shift || true; break ;;
Erick Reyes5104a6c2018-06-27 15:31:58 -070050 push) PUSH=1; shift || true; break ;;
Joel Fernandes6975db22018-07-11 20:53:16 -070051 prepare) PREPARE=1; shift || true; ;;
52 --full) FULL=1; config_full_build; shift || true; ;;
Joel Fernandes (Google)08d1a072018-05-28 13:29:03 -070053 --arch) ARCH=$2; shift || true; shift || true; ;;
Joel Fernandes (Google)387c8952018-07-25 16:27:49 -070054 --archive) DOWNLOAD=0; TARF=$2; shift || true; shift || true; ;;
Joel Fernandes (Google)60ab9282018-08-17 12:11:52 -070055 --bcc) FULL=1; source $spath/packages/bcc; shift || true; ;;
Joel Fernandes5b4be9c2018-03-30 23:58:27 -070056 --kernelsrc) KERNELSRC="$2"; shift || true; shift || true; ;;
Joel Fernandes (Google)1171d2d2018-05-30 17:22:09 -070057 --skip-install) SKIP_INSTALL=1; shift || true; ;;
Joel Fernandes1ed30d72018-05-18 14:08:20 -070058 --kernel-headers-targz) KERNELHDRS=$2; shift || true; shift || true; ;;
Joel Fernandese2a04662018-03-31 19:33:23 -070059 --tempdir) TDIR="$2"; shift || true; shift || true; ;;
Joel Fernandes6975db22018-07-11 20:53:16 -070060 --build) DOWNLOAD=0; shift || true; ;;
61 --buildtar) BTAR=1; DOWNLOAD=0; TARDIR="$2"; shift || true; shift || true; ;;
Joel Fernandes02939a32018-04-02 22:18:10 -070062 --device|-s) ADB="$ADB -s $2"; shift || true; shift || true; ;;
Joel Fernandes (Google)5e40e892018-10-14 13:14:34 -070063 --build-image) BI=1; BUILD_IMAGEF=$2; SKIP_DEVICE=1; DOWNLOAD=0; shift || true; shift || true; ;;
Joel Fernandesca8fb552018-04-01 13:48:16 -070064 --debug) set -x; shift || true; ;;
Joel Fernandes112243b2018-07-08 17:42:48 -070065 *) c_error "Unknown option ($1)"; usage; ;;
Joel Fernandes6c1ca312018-03-30 17:13:15 -070066esac
67done
68
Joel Fernandesc7551962018-07-10 14:12:19 -070069[ -z $ASHELL ] && box_out "adeb: $VERSION"
Joel Fernandesdd102af2018-07-08 19:38:42 -070070
Joel Fernandes6975db22018-07-11 20:53:16 -070071if [ $FULL -eq 1 ]; then
72 FNAME=androdeb-fs.tgz.zip
73 FNAME_UZ=androdeb-fs.tgz
74else
75 FNAME=androdeb-fs-minimal.tgz.zip
76 FNAME_UZ=androdeb-fs-minimal.tgz
77fi
78
Joel Fernandesddd28032018-07-08 23:13:17 -070079if [ ! -z $BTAR ] && [ -z $TARDIR ]; then
80 TARDIR=$spath
81fi
82
Erick Reyese25caea2018-06-19 15:42:59 -070083if [ ! -z "$GIT_PULL" ]; then
Joel Fernandes112243b2018-07-08 17:42:48 -070084 c_info "Updating androdeb by git pull"
Joel Fernandes16371152018-04-05 22:50:36 -070085 cd $spath
86 git pull
Joel Fernandes112243b2018-07-08 17:42:48 -070087 c_info "Done."
Joel Fernandes16371152018-04-05 22:50:36 -070088 exit 0
89fi
90
Erick Reyese25caea2018-06-19 15:42:59 -070091if [ ! -z "$PULL" ]; then
92 if [ $1 == "-a" ]; then
93 PRESERVE="-a"
Joel Fernandes112243b2018-07-08 17:42:48 -070094 c_info "Preserving filestamps and mode"
Erick Reyese25caea2018-06-19 15:42:59 -070095 shift || true
96 fi
Erick Reyes5104a6c2018-06-27 15:31:58 -070097 file_count=`count_sources $@`
Erick Reyese25caea2018-06-19 15:42:59 -070098 i=0
99 while [ $i -lt $file_count ]; do
100 files["$i"]=/data/androdeb/debian/$1
101 shift || true
102 i=$((i + 1))
103 done
104 $ADB pull $PRESERVE "${files[@]}" "$@"
105 exit 0
106fi
107
Erick Reyes5104a6c2018-06-27 15:31:58 -0700108if [ ! -z "$PUSH" ]; then
Erick Reyes5104a6c2018-06-27 15:31:58 -0700109 file_count=`count_sources $@`
110 i=0
111 while [ $i -lt $file_count ]; do
112 files["$i"]=$1
113 shift || true
114 i=$((i + 1))
115 done
116 dest=/data/androdeb/debian/$1
117 $ADB push $sync "${files[@]}" $dest
118 exit 0
119fi
120
Joel Fernandes97958e12018-03-31 23:51:44 -0700121if [[ ! -z ${TARDIR+x} ]] && [[ ! -d $TARDIR ]]; then die 7 "Tar dir specified doesn't exist"; fi
Joel Fernandes92057762018-03-31 23:38:43 -0700122
Joel Fernandesfdc52002018-07-08 18:49:20 -0700123if [ -z $BI ]; then
Joel Fernandesdd102af2018-07-08 19:38:42 -0700124 [ -z $ASHELL ] && c_info "Looking for device.."
Joel Fernandes (Google)9ed573a2018-07-25 16:07:55 -0700125 set +e
Joel Fernandesc26696d2018-07-08 18:28:12 -0700126 do_adb_root "$ADB"
Joel Fernandesaf07ec72018-04-02 22:01:19 -0700127
Joel Fernandesc26696d2018-07-08 18:28:12 -0700128 if [ $? -ne 0 ]; then
129 c_error "adb root failed, make sure:"
130 c_error " * If multiple devices connected, provide --device <serialno> (or -s <serialno>)"
131 c_error " * Try to run \"adb root\" manually and see if it works. Typically this needs a userdebug build."
132 c_error ""
133 c_error "Note: adb can be typically obtained using the android-tools-adb or the adb"
134 c_error "packages on your distro, or by installing the Android SDK."
135 die 3 "Exiting."
136 fi
Joel Fernandes (Google)9ed573a2018-07-25 16:07:55 -0700137 set -e
Joel Fernandesfdc52002018-07-08 18:49:20 -0700138else
139 [ ! -z $BUILD_IMAGEF ] || die 8 "--build-image passed but no image file provided"
Joel Fernandes (Google)9c3ae932018-05-28 14:34:48 -0700140fi
Joel Fernandes72656c52018-03-31 20:35:33 -0700141
Joel Fernandesb4c80a62018-04-02 22:37:22 -0700142if [ ! -z "$REMOVE" ]; then
143 die_if_no_androdeb "Nothing to remove."
Joel Fernandes (Google)7c8b1082018-06-25 12:29:10 -0700144 $ADB shell /data/androdeb/device-umount-all || true;
Joel Fernandesb4c80a62018-04-02 22:37:22 -0700145 $ADB shell rm -rf /data/androdeb; exit 0; fi
146
Joel Fernandes83676b12018-03-30 23:33:47 -0700147##########################################################
Joel Fernandese2a04662018-03-31 19:33:23 -0700148# SHELL
Joel Fernandes83676b12018-03-30 23:33:47 -0700149##########################################################
Joel Fernandese381ac72018-03-31 21:46:36 -0700150if [ ! -z ${ASHELL+x} ]; then
Joel Fernandes02939a32018-04-02 22:18:10 -0700151 set +e; $ADB shell ls /data/androdeb/debian/.bashrc > /dev/null 2>&1
Joel Fernandesc9646812018-03-31 19:45:46 -0700152 if [ $? -ne 0 ]; then
153 die 2 "Device doesn't have an androdeb environment, run \"./androdeb prepare\" first";
154 fi; set -e
155
Joel Fernandesccb993f2018-07-02 19:59:04 -0700156 if [ ! -z ${SHELL_ARGS+x} ]; then
157 # Explanation of quotes:
158 # Outer quote is so that androdeb's bash passes the SHELL_ARGS as a single
159 # argument to $ADB shell. Inner quotes is so that run-command can receive all
160 # the args even though they may be separated by spaces. \m/
161 $ADB shell -t /data/androdeb/run-command "\"$SHELL_ARGS\""
162 else
163 $ADB shell -t /data/androdeb/run
164 fi
165
Joel Fernandese2a04662018-03-31 19:33:23 -0700166 exit 0
167fi
168
169##########################################################
170# PREPARE
171##########################################################
Joel Fernandesf0c54092018-04-01 19:05:10 -0700172
173function do_cleanup() {
174 rm -rf $TDIR/*; if [ $MKTEMP -eq 1 ]; then rm -rf $TDIR; fi
175}
176
177function push_unpack_headers() {
Joel Fernandesb4c80a62018-04-02 22:37:22 -0700178 die_if_no_androdeb "Couldn't update headers."
Joel Fernandesf0c54092018-04-01 19:05:10 -0700179
Joel Fernandesf95f2b22018-07-08 17:54:47 -0700180 c_info "Storing kernel headers into androdeb /kernel-headers/"
Joel Fernandes02939a32018-04-02 22:18:10 -0700181 $ADB shell rm -rf /data/androdeb/debian/kernel-headers/
182 $ADB shell mkdir /data/androdeb/debian/kernel-headers/
Joel Fernandesf95f2b22018-07-08 17:54:47 -0700183 run_quiet $ADB push $TDIR_ABS/kh.tgz /data/androdeb/
Joel Fernandes02939a32018-04-02 22:18:10 -0700184 $ADB shell tar -xvf /data/androdeb/kh.tgz -C /data/androdeb/debian/kernel-headers/ > /dev/null
185 $ADB shell rm /data/androdeb/kh.tgz
Joel Fernandesf0c54092018-04-01 19:05:10 -0700186}
187
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700188function push_unpack_tarred_headers() {
189 die_if_no_androdeb "Couldn't update headers."
190
191 $ADB shell rm -rf /data/androdeb/debian/kernel-headers/
192 $ADB shell mkdir /data/androdeb/debian/kernel-headers/
Joel Fernandesf95f2b22018-07-08 17:54:47 -0700193
194 c_info "Pushing headers tar onto device"
195 run_quiet $ADB push $1 /data/androdeb/
196
Joel Fernandes112243b2018-07-08 17:42:48 -0700197 c_info "Storing kernel headers into androdeb root directory"
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700198 $ADB shell tar -xvf /data/androdeb/$(basename $1) -C /data/androdeb/debian/ > /dev/null
199
200 $ADB shell rm /data/androdeb/$(basename $1)
201}
202
Joel Fernandes72065112018-04-01 20:02:53 -0700203function all_done_banner() {
Joel Fernandes6975db22018-07-11 20:53:16 -0700204 c_info "All done! Run \"adeb shell\" to enter environment"
Joel Fernandes72065112018-04-01 20:02:53 -0700205}
206
Erick Reyeseb6bc732018-08-16 15:39:48 -0700207function detect_repo_url() {
Erick Reyesab569272018-08-17 16:02:00 -0700208 ADEB_REPO_URL=`cd $spath && git config -l | grep -m1 remote | grep url | sed -e "s/.*url=//" \
Erick Reyeseb6bc732018-08-16 15:39:48 -0700209 -e "s/.*@//" \
210 -e "s/https:\/\///" \
211 -e "s/:/\//" \
212 -e "s/\.git$//"`"/"
213 c_info "Detected URL: $ADEB_REPO_URL"
214}
215
Erick Reyesde9be052018-08-02 20:08:28 -0700216function check_repo_url () {
Erick Reyeseb6bc732018-08-16 15:39:48 -0700217 if [ -z $ADEB_REPO_URL ]; then
218 c_info "No repository URL provided in enviromnent. Attempting to auto-detect it"
219 detect_repo_url
220 fi
221
222 if [ -z $ADEB_REPO_URL ]; then
223 c_warning "Automatic download is disabled. To enable it, please set the \$ADEB_REPO_URL"
224 c_warning "environment variable as recommended in the setup instructions in the README.md"
225 do_cleanup
226 exit 0
227 fi
Erick Reyesde9be052018-08-02 20:08:28 -0700228}
229
230function download_headers() {
231 KERNEL_MAJOR=`$ADB shell uname -r | cut -d - -f 1 | cut -d . -f 1`
232 KERNEL_MINOR=`$ADB shell uname -r | cut -d - -f 1 | cut -d . -f 2`
233 KERNEL_VERSION="$KERNEL_MAJOR.$KERNEL_MINOR"
Erick Reyesdd195c02018-08-16 14:50:47 -0700234 PREBUILT_HEADERS_FILE=headers-$ARCH-$KERNEL_VERSION.tar.gz.zip
Erick Reyesde9be052018-08-02 20:08:28 -0700235
236 check_repo_url
237
Erick Reyesdd195c02018-08-16 14:50:47 -0700238 curl -L https://$ADEB_REPO_URL/releases/download/$VERSION/$PREBUILT_HEADERS_FILE --output $TDIR_ABS/$PREBUILT_HEADERS_FILE ||
239 die 9 "Failed to download kernel headers. Please check your internet connection and repository URL"
Erick Reyesde9be052018-08-02 20:08:28 -0700240
241 unzip -e $TDIR_ABS/$PREBUILT_HEADERS_FILE -d $TDIR_ABS/ ||
Erick Reyesdd195c02018-08-16 14:50:47 -0700242 die 10 "Failed to download kernel headers. Kernel $KERNEL_VERSION for $ARCH may not be supported or ADEB_REPO_URL is incorrect."
Erick Reyesde9be052018-08-02 20:08:28 -0700243 KERNELHDRS=$TDIR_ABS/`echo "$PREBUILT_HEADERS_FILE" | sed "s/.zip//"`
244}
245
Joel Fernandes72656c52018-03-31 20:35:33 -0700246# Prepare is the last command checked
Joel Fernandes9f00bf42018-04-01 10:36:33 -0700247if [ -z "$PREPARE" ]; then usage; fi
Joel Fernandes72656c52018-03-31 20:35:33 -0700248
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700249if [ ! -z "$TARF" ] && [ ! -f $TARF ] && [ -z "$DOWNLOAD" ]; then die 5 "archive provided doesn't exist"; fi
Joel Fernandes9f00bf42018-04-01 10:36:33 -0700250
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700251if [ ! -z "$KERNELSRC" ] && [ ! -d $KERNELSRC ]; then die 6 "Kernel source directory provided doesn't exist"; fi
252
253if [ ! -z "$KERNELHDRS" ] && [ ! -f $KERNELHDRS ]; then die 7 "Kernel headers tar.gz doesn't exist"; fi
Joel Fernandese2a04662018-03-31 19:33:23 -0700254
Joel Fernandesca8fb552018-04-01 13:48:16 -0700255print_prepare_banner
256
Joel Fernandes6c1ca312018-03-30 17:13:15 -0700257# Where do we want to store temporary files
Joel Fernandese2a04662018-03-31 19:33:23 -0700258MKTEMP=0; if [[ -z ${TDIR+x} ]] || [[ ! -d "${TDIR}" ]]; then
259 TDIR=`mktemp -d`; MKTEMP=1; fi
Joel Fernandese381ac72018-03-31 21:46:36 -0700260rm -rf $TDIR/*
261TDIR_ABS=$( cd "$TDIR" ; pwd -P )
Joel Fernandes6c1ca312018-03-30 17:13:15 -0700262
Joel Fernandes6975db22018-07-11 20:53:16 -0700263if [ $DOWNLOAD -eq 1 ]; then
Joel Fernandes112243b2018-07-08 17:42:48 -0700264 c_info "Downloading Androdeb from the web..."; c_info ""
Joel Fernandes6975db22018-07-11 20:53:16 -0700265
Joel Fernandes (Google)9e670aa2018-06-25 13:39:34 -0700266 # Github dropped tar gz support! ##?#??#! Now we've to zip everything.
Erick Reyesde9be052018-08-02 20:08:28 -0700267 check_repo_url
Joel Fernandes (Google)db9005f2018-07-25 16:44:12 -0700268
Erick Reyesdd195c02018-08-16 14:50:47 -0700269 curl -L https://$ADEB_REPO_URL/releases/download/$VERSION/$FNAME --output $TDIR_ABS/$FNAME ||
Joel Fernandes (Google)db9005f2018-07-25 16:44:12 -0700270 die 9 "Failed to download adeb release."
271
272 unzip -e $TDIR_ABS/$FNAME -d $TDIR_ABS/ ||
273 die 10 "Failed to download adeb release. Double check the ADEB_REPO_URL value."
Joel Fernandes6975db22018-07-11 20:53:16 -0700274 TARF=$TDIR_ABS/$FNAME_UZ
275fi
Joel Fernandesa67be0b2018-04-01 13:40:34 -0700276
Joel Fernandes (Google)5e40e892018-10-14 13:14:34 -0700277if [ ! -z "$FULL" ] && [ -z "$KERNELSRC" ] && [ -z "$KERNELHDRS" ] && [ -z "$BI" ]; then
Erick Reyesde9be052018-08-02 20:08:28 -0700278 c_info "Kernel headers are needed but none were provided. Downloading pre-built headers"
279 download_headers
280fi
281
Joel Fernandese2a04662018-03-31 19:33:23 -0700282OUT_TMP=$TDIR/debian; rm -rf $OUT_TMP; mkdir -p $OUT_TMP
Joel Fernandesf0c54092018-04-01 19:05:10 -0700283
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700284# Unpack the supplied kernel headers tar.gz directly into androdeb root
285if [ ! -z "$KERNELHDRS" ]; then
Joel Fernandes112243b2018-07-08 17:42:48 -0700286 c_info "Building updating kernel headers from supplied tar.gz ($KERNELHDRS)"
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700287
288 # Is header tar gz update the only thing left to do?
Joel Fernandes (Google)1171d2d2018-05-30 17:22:09 -0700289 if [[ ! -z "$SKIP_INSTALL" ]]; then
Joel Fernandes112243b2018-07-08 17:42:48 -0700290 c_info "Skipping install"
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700291 push_unpack_tarred_headers $KERNELHDRS; do_cleanup; all_done_banner; exit 0; fi
292
293 tar -xvf $KERNELHDRS -C $OUT_TMP/ > /dev/null
294fi
295
Joel Fernandesf0c54092018-04-01 19:05:10 -0700296# Package kernel headers
297if [ ! -z "$KERNELSRC" ]; then
Joel Fernandes112243b2018-07-08 17:42:48 -0700298 c_info "Building and updating kernel headers from kernel source dir ($KERNELSRC)"
Joel Fernandes72065112018-04-01 20:02:53 -0700299 $spath/bcc/build-kheaders-targz.sh ${KERNELSRC} $TDIR_ABS/kh.tgz > /dev/null
300
Joel Fernandesf0c54092018-04-01 19:05:10 -0700301 # Is header update the only thing left to do?
Joel Fernandes (Google)1171d2d2018-05-30 17:22:09 -0700302 if [[ ! -z "$SKIP_INSTALL" ]]; then
Joel Fernandes112243b2018-07-08 17:42:48 -0700303 c_info "Skipping install"
Joel Fernandes72065112018-04-01 20:02:53 -0700304 push_unpack_headers; do_cleanup; all_done_banner; exit 0; fi
Joel Fernandesf0c54092018-04-01 19:05:10 -0700305
Joel Fernandese381ac72018-03-31 21:46:36 -0700306 mkdir $OUT_TMP/kernel-headers
Joel Fernandes72065112018-04-01 20:02:53 -0700307 tar -xvf $TDIR_ABS/kh.tgz -C $OUT_TMP/kernel-headers/ > /dev/null
Joel Fernandese381ac72018-03-31 21:46:36 -0700308fi
Joel Fernandes4fb97ea2018-03-31 11:15:19 -0700309
Joel Fernandesf0c54092018-04-01 19:05:10 -0700310# Build FS from existing tar, very simple.
Joel Fernandes9f00bf42018-04-01 10:36:33 -0700311if [ ! -z "$TARF" ]; then
Joel Fernandes112243b2018-07-08 17:42:48 -0700312 c_info "Using archive at $TARF for filesystem preparation"
Joel Fernandes02939a32018-04-02 22:18:10 -0700313 $ADB shell mkdir -p /data/androdeb/
Joel Fernandesf95f2b22018-07-08 17:54:47 -0700314
315 c_info "Pushing filesystem to device.."
316 run_quiet $ADB push $TARF /data/androdeb/deb.tar.gz
317
318 c_info "Pushing addons to device.."
319 run_quiet $ADB push $spath/addons/* /data/androdeb/
320
321 c_info "Unpacking filesystem in device.."
322 run_quiet $ADB shell /data/androdeb/device-unpack
Joel Fernandes9f00bf42018-04-01 10:36:33 -0700323
Joel Fernandes1ed30d72018-05-18 14:08:20 -0700324 if [ ! -z "$KERNELHDRS" ]; then push_unpack_tarred_headers $KERNELHDRS; fi
Joel Fernandesf0c54092018-04-01 19:05:10 -0700325 if [ ! -z "$KERNELSRC" ]; then push_unpack_headers; fi
326
Joel Fernandes72065112018-04-01 20:02:53 -0700327 do_cleanup; all_done_banner; exit 0
Joel Fernandesf0c54092018-04-01 19:05:10 -0700328fi
329
330PACKAGES+="$DEFAULT_PACKAGES"
Joel Fernandes112243b2018-07-08 17:42:48 -0700331c_info "Using temporary directory: $TDIR"
Joel Fernandes4fb97ea2018-03-31 11:15:19 -0700332
Joel Fernandes112243b2018-07-08 17:42:48 -0700333if [[ $EUID -ne 0 ]]; then c_info "The next stage runs as sudo, please enter password if asked."; fi
Joel Fernandes4fb97ea2018-03-31 11:15:19 -0700334
Joel Fernandes (Google)57b3fd22018-05-29 16:27:03 -0700335ex_files=$(mktemp); echo $EXTRA_FILES > $ex_files
336
Joel Fernandes (Google)4f711082018-05-29 16:23:15 -0700337sudo $spath/buildstrap $ARCH $DISTRO $TDIR $OUT_TMP \
338 "$(make_csv "$PACKAGES")"\
Joel Fernandesfdc52002018-07-08 18:49:20 -0700339 $ex_files $INSTALL_BCC $SKIP_DEVICE
Joel Fernandes (Google)57b3fd22018-05-29 16:27:03 -0700340rm $ex_files
Joel Fernandes (Google)9c3ae932018-05-28 14:34:48 -0700341
342# If we only wanted to prepare a rootfs and don't have
343# a device connected, then just echo that and skip cleanup
Joel Fernandesfdc52002018-07-08 18:49:20 -0700344if [ $SKIP_DEVICE -eq 1 ]; then
345 c_info "Device preparation is being skipped for the selected options"
Joel Fernandesba7214e2018-07-08 18:15:49 -0700346 c_info "any builds that need to happen on device may be cloned but not built."
Joel Fernandes47ef2152018-07-08 19:13:51 -0700347
348 if [ ! -z $BI ]; then
349 sudo $spath/buildimage $OUT_TMP $(dirname $BUILD_IMAGEF)/$(basename $BUILD_IMAGEF)
350 sudo chmod a+rw $(dirname $BUILD_IMAGEF)/$(basename $BUILD_IMAGEF)
Joel Fernandes9a38e602018-07-08 19:26:32 -0700351 c_info "Your .img has been built! Enjoy!"
Joel Fernandes47ef2152018-07-08 19:13:51 -0700352 fi
Joel Fernandesba7214e2018-07-08 18:15:49 -0700353
354 do_cleanup
Joel Fernandes9a38e602018-07-08 19:26:32 -0700355 exit 0
Joel Fernandes (Google)9c3ae932018-05-28 14:34:48 -0700356fi
Joel Fernandes4dd60862018-03-31 13:27:16 -0700357
358# Push tar to device and start unpack
Joel Fernandes02939a32018-04-02 22:18:10 -0700359$ADB shell mkdir -p /data/androdeb/
360$ADB push $TDIR/deb.tar.gz /data/androdeb/
361$ADB push $spath/addons/* /data/androdeb/
362$ADB shell /data/androdeb/device-unpack
Joel Fernandesb61d27d2018-03-31 11:59:45 -0700363
Joel Fernandes6f1c70f2018-03-31 20:26:26 -0700364# Build BCC and install bcc on device if needed
Joel Fernandes241160e2018-07-08 23:36:11 -0700365if [ $INSTALL_BCC -eq 1 ]; then
Joel Fernandesffcbfe42018-07-08 19:08:02 -0700366 $ADB shell /data/androdeb/run-command /bcc-master/build-bcc.sh;
367fi
Joel Fernandes4fb97ea2018-03-31 11:15:19 -0700368
Joel Fernandes97958e12018-03-31 23:51:44 -0700369# Extract a tar of the built, compiled and installed androdeb env
370if [[ ! -z ${TARDIR+x} ]]; then
Joel Fernandes6975db22018-07-11 20:53:16 -0700371 c_info "Creating tarball"
372 pushd $TARDIR
373 if [ $INSTALL_BCC -eq 0 ]; then
374 mv $TDIR/deb.tar.gz $FNAME_UZ
375 else
376 $ADB shell /data/androdeb/build-debian-tar
377 $ADB pull /data/androdeb/androdeb-fs.tgz $FNAME_UZ
378 $ADB shell rm /data/androdeb/androdeb-fs.tgz;
379 fi
380 zip -r $FNAME $FNAME_UZ
381 popd
382fi
383
384do_cleanup
Joel Fernandes97958e12018-03-31 23:51:44 -0700385
Joel Fernandes72065112018-04-01 20:02:53 -0700386all_done_banner